Index: trunk/kernel/syscalls/sys_thread_detach.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_detach.c	(revision 690)
+++ trunk/kernel/syscalls/sys_thread_detach.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_thread_detach.c - detach a joinable thread
+ * kern/sys_thread_detach.c - detach a joinable thread
  * 
- * Authors   Alain Greiner (2016,2017,2018,2019)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c)  UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,70 +17,69 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_remote.h>
-#include <hal_special.h>
+#include <list.h>
 #include <thread.h>
+#include <kmem.h>
+#include <kmagics.h>
 #include <errno.h>
-#include <printk.h>
+#include <task.h>
+#include <spinlock.h>
 
-#include <syscalls.h>
+int sys_thread_detach (pthread_t tid)
+{
+	register struct task_s *task;
+	struct thread_s *target_th;
+	uint_t state;
+	error_t err;
 
-//////////////////////////////////////
-int sys_thread_detach( trdid_t trdid )
-{
-    xptr_t       target_xp;
-	thread_t   * target_ptr;
-    cxy_t        target_cxy;
-    ltid_t       target_ltid;
-    uint32_t     flags;
+	task = current_task;
 
-	thread_t   * this    = CURRENT_THREAD;
-    process_t  * process = this->process;
+	if(tid > task->max_order)
+	{
+		err = EINVAL;
+		goto fail_arg;
+	}
+ 
+	spinlock_lock(&task->th_lock);
 
-    // get target thread ltid and cxy
-    target_ltid = LTID_FROM_TRDID( trdid );
-    target_cxy  = CXY_FROM_TRDID( trdid );
+	target_th = task->th_tbl[tid];
+   
+	if((target_th == NULL)                 ||
+	   (target_th->signature != THREAD_ID) || 
+	   (target_th->info.attr.key != tid))
+	{
+		err = ESRCH;
+		goto fail_srch;
+	}
+  
+	if(!(thread_isJoinable(target_th)))
+	{
+		err = EINVAL;
+		goto fail_not_joinable;
+	}
+  
+	err = 0;
 
-    // check trdid argument
-	if( (target_ltid >= CONFIG_THREADS_MAX_PER_CLUSTER) ||
-        (cluster_is_active( target_cxy ) == false) )  
+	spinlock_lock(&target_th->lock);
+
+	thread_clear_joinable(target_th);
+
+	if((target_th->info.join == NULL) && 
+	   !(state = wait_queue_isEmpty(&target_th->info.wait_queue)))
 	{
-        printk("\n[ERROR] in %s : illegal trdid argument\n", __FUNCTION__ );
-		this->errno = EINVAL;
-		return -1;
+		wakeup_one(&target_th->info.wait_queue, WAIT_ANY);
 	}
 
-    // get extended pointer on target thread
-	target_xp  = thread_get_xptr( process->pid , trdid );
+	spinlock_unlock(&target_th->lock);
+  
+fail_not_joinable:
+fail_srch:
+	spinlock_unlock(&task->lock);
 
-    if( target_xp == XPTR_NULL )
-    {
-        printk("\n[ERROR] in %s : target thread not found\n", __FUNCTION__ );
-        this->errno = ESRCH;
-        return -1;
-    }
-
-    // get local pointer on target thread
-    target_ptr = (thread_t *)GET_PTR( target_xp );
-
-    // get target thread flags
-    flags = hal_remote_l32( XPTR( target_cxy , &target_ptr->flags ) );
-
-    // check target thread joinable
-    if( flags & THREAD_FLAG_DETACHED )
-    {
-        printk("\n[ERROR] in %s : target thread not joinable\n", __FUNCTION__ );
-        this->errno = EINVAL; 
-        return -1;
-    }
-
-    // atomically set the thread DETACHED flag
-    hal_remote_atomic_or( XPTR( target_cxy , &target_ptr->flags ) , THREAD_FLAG_DETACHED );
-
-	return 0;
-
-}  // end sys_thread_detach()
+fail_arg:
+	current_thread->info.errno = err;
+	return err;
+}
Index: trunk/kernel/syscalls/sys_thread_exit.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_exit.c	(revision 690)
+++ trunk/kernel/syscalls/sys_thread_exit.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_thread_exit.c - terminates the execution of calling thread
+ * kern/sys_thread_exit.c - terminates the execution of current thread
  * 
- * Authors   Alain Greiner (2016,2017,2018,2019,2020)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,102 +17,77 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_irqmask.h>
+#include <list.h>
 #include <thread.h>
+#include <scheduler.h>
+#include <wait_queue.h>
+#include <cluster.h>
+#include <dqdt.h>
 #include <process.h>
-#include <core.h>
-#include <vmm.h>
-#include <scheduler.h>
-#include <printk.h>
 
-#include <syscalls.h>
+///////////////////////////////////////
+int sys_thread_exit ( void * exit_val )
+{
+	thread_t * this = current_thread;
+    cpu_t    * cpu  = current_cpu;
+	uint32_t   state;
+	bool_t     isEmpty;
+	bool_t     isReleased;
 
-/////////////////////////////////////////
-int sys_thread_exit( void * exit_status )
-{
-    error_t     error;
-    vseg_t    * vseg;
+	/* TODO: the cpu->lid must match the core index in the logical cluster */
+	if(this->process->pid != 1)
+		dqdt_update_threads_number( local_cxy , cpu->lid , -1 );
 
-	thread_t  * this      = CURRENT_THREAD;
-    trdid_t     trdid     = this->trdid;
-    process_t * process   = this->process;
-    pid_t       pid       = process->pid;
-    
-#if DEBUG_SYS_THREAD_EXIT || DEBUG_SYSCALLS_ERROR 
-uint64_t     tm_start = hal_get_cycles();
-#endif
+	spinlock_lock( &this->lock );
 
-    // check exit_value pointer in user space if required
-    if( exit_status != NULL )
-    {
-        error = vmm_get_vseg( process , (intptr_t)exit_status  , &vseg );
+	if(!(thread_isJoinable(this)))
+	{
+		spinlock_unlock_nosched(&this->lock);
+		goto exit_dead;
+	}
 
-    	if( error )
-	    {
+	// Check if there's a thread waiting the end of callee thread
+	isEmpty = wait_queue_isEmpty(&this->info.wait_queue);
 
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start ) 
-printk("\n[WARNING] in %s : exit_status buffer %x unmapped / thread[%x,%x]\n",
-__FUNCTION__, (intptr_t)exit_status, pid, trdid );
-#endif
-            this->errno = EINVAL;
-	        return -1;
-        }
-    }
+	if(isEmpty)
+	{
+		this->info.exit_value = exit_val;
+		wait_on(&this->info.wait_queue, WAIT_ANY);
+		spinlock_unlock_nosched(&this->lock);
+		sched_sleep(this);
+	}
+	else
+	{
+		this->info.join->info.exit_value = exit_val;
+		wakeup_one(&this->info.wait_queue, WAIT_ANY);
+		spinlock_unlock_nosched(&this->lock);
+	}
 
-	// check busylocks
-    uint32_t count = this->busylocks;
-	if( count )
+exit_dead:
+
+	isReleased = false;
+
+	// Release FPU if required
+	cpu_disable_all_irq(&state);
+	if(current_cpu->fpu_owner == this)
 	{
+		current_cpu->fpu_owner = NULL;
+		isReleased = true;
+	}
+	cpu_restore_irq(state);
 
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start ) 
-printk("\n[WARNING] in %s : busylocks count = %d  / thread[%x,%x]\n",
-__FUNCTION__ , count, pid, trdid );
-#endif
-            this->errno = EINVAL;
-	        return -1;
-    }
+	if(isReleased)
+	{
+		thread_dmsg(1, "INFO: Thread %x has released FPU on CPU %d\n",
+		       this, 
+		       current_cpu->gid);
+	}
 
-    // If calling thread is the main thread, the process must be deleted. 
-    // => delete all process threads and synchronize with parent process.
-    // If calling thread is not the main thread, only this thread must be deleted.
-    // => register exit_status in thread descriptor, block the thread, 
-    //    mark it for delete, and synchronize with joining thread. 
+	sched_exit(this);
 
-    if( (CXY_FROM_PID( pid ) == local_cxy) && (LTID_FROM_TRDID(trdid) == 0) )  // main
-    {
-
-#if DEBUG_SYS_THREAD_EXIT
-if( DEBUG_SYS_THREAD_EXIT < (uint32_t)tm_start ) 
-printk("\n[%s] thread[%x,%x] is main => delete process / cycle %d\n",
-__FUNCTION__ , pid , trdid , (uint32_t)tm_start );
-#endif
-        // delete process
-        sys_exit( 0 );
-    }
-    else                                                             // not the main
-    {
-
-#if DEBUG_SYS_THREAD_EXIT
-if( DEBUG_SYS_THREAD_EXIT < (uint32_t)tm_start )
-printk("\n[%s] thread[%x,%x] is not main => delete thread / cycle %d\n",
-__FUNCTION__ , pid , trdid , (uint32_t)tm_start );
-#endif
-        // register exit_status in thread descriptor
-        this->exit_status = exit_status;
-
-        // block calling thread and mark it for delete,
-        thread_delete_request( XPTR( local_cxy , this ) , false );   // not forced
-
-        // deschedule
-        sched_yield( "suicide after thread_exit" );
-    }
-
-    return 0;   // never executed but required by compiler
-
-}  // end sys_thread exit
+	PANIC ("Thread %x, CPU %d must never return", this, current_cpu->gid);
+	return -1;		/* Fake return ! */
+}
Index: trunk/kernel/syscalls/sys_thread_getattr.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_getattr.c	(revision 1)
+++ trunk/kernel/syscalls/sys_thread_getattr.c	(revision 1)
@@ -0,0 +1,54 @@
+/*
+ * kern/sys_thread_getattr.c - gets current thread's attributes
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <errno.h>
+#include <cpu.h>
+#include <cluster.h>
+#include <thread.h>
+
+int sys_thread_getattr(pthread_attr_t *attr)
+{
+	struct thread_s *this;
+	struct cpu_s *cpu;
+	error_t err;
+
+	this = current_thread;
+	cpu  = current_cpu;
+	
+	if(NOT_IN_USPACE((uint_t)attr))
+	{
+		err = EPERM;
+		goto fail_attr;
+	}
+
+	this->info.attr.cid     = cpu->cluster->id;
+	this->info.attr.cpu_lid = cpu->lid;
+	this->info.attr.cpu_gid = cpu->gid;
+  
+	err = cpu_copy_to_uspace(attr, &this->info.attr,
+				 sizeof(pthread_attr_t));
+
+fail_attr:
+	this->info.errno = err;
+	return err;
+}
Index: trunk/kernel/syscalls/sys_thread_join.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_join.c	(revision 690)
+++ trunk/kernel/syscalls/sys_thread_join.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_thread_join.c - wait termination of of an attached thread.
+ * kern/sys_thread_join.c - passive wait on the end of a given thread
  * 
- * Authors    Alain Greiner (2016,2017,2018,2019)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,208 +17,113 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_remote.h>
-#include <hal_special.h>
-#include <hal_irqmask.h>
-#include <hal_uspace.h>
+#include <list.h>
 #include <thread.h>
-#include <vmm.h>
 #include <scheduler.h>
+#include <kmem.h>
 #include <errno.h>
-#include <printk.h>
-#include <remote_busylock.h>
+#include <task.h>
+#include <spinlock.h>
 
-#include <syscalls.h>
+int sys_thread_join (pthread_t tid, void **thread_return)
+{
+	register struct task_s *task;
+	register struct thread_s *this;
+	register struct thread_s *target_th;
+	register uint_t state = 0;
+	void *retval;
+	int err;
 
-///////////////////////////////////////
-int sys_thread_join ( trdid_t    trdid,
-                      void    ** exit_status )
-{
-    error_t       error;
-    reg_t         save_sr;
-    xptr_t        target_xp;
-    thread_t    * target_ptr;
-    cxy_t         target_cxy;
-    ltid_t        target_ltid;
-    xptr_t        target_join_lock_xp;
-    xptr_t        target_flags_xp;
-    xptr_t        target_join_xp_xp;
-    xptr_t        target_exit_status_xp;
-    xptr_t        killer_xp;
-    xptr_t        joining_xp;
-    thread_t    * joining_ptr;
-    process_t   * process;
-    vseg_t      * vseg;
-    void        * status;
+	this   = current_thread;
+	task   = this->task;
+	retval = 0;
 
-    // get joining thread pointers
-	joining_ptr = CURRENT_THREAD;
-    joining_xp  = XPTR( local_cxy , joining_ptr );
-    process     = joining_ptr->process;
-
-    // get target thread ltid and cxy
-    target_ltid = LTID_FROM_TRDID( trdid );
-    target_cxy  = CXY_FROM_TRDID( trdid );
-
-#if DEBUG_SYS_THREAD_JOIN
-uint64_t  tm_start = hal_get_cycles();
-if( DEBUG_SYS_THREAD_JOIN < tm_start )
-printk("\n[%s] joining thread[%x,%x] enter / target thread[%x,%x] / cycle %d\n",
-__FUNCTION__ , process->pid, joining_ptr->trdid,
-process->pid, trdid, (uint32_t)tm_start );
-#endif
-
-    // check trdid argument
-	if( (target_ltid >= CONFIG_THREADS_MAX_PER_CLUSTER) || 
-        (cluster_is_active(target_cxy) == false) )
+	if((tid > task->max_order) || 
+	   ((thread_return != NULL) && 
+	    (NOT_IN_USPACE((uint_t)thread_return + sizeof(void*)))))
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : illegal trdid argument %x / joining thread[%x,%x]\n",
-__FUNCTION__, trdid, joining_ptr->process->pid, joining_ptr-trdid );
-#endif
-		joining_ptr->errno = EINVAL;
-		return -1;
+		err = EINVAL;
+		goto fail_arg;
 	}
 
-    // check exit_value argument in user space
-    error = vmm_get_vseg( process , (intptr_t)exit_status  , &vseg );
-	if( error )
+	/* try to write to userland address */
+	if(thread_return)
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : exit_status argument %x not mapped / joining thread[%x,%x]\n",
-__FUNCTION__, exit_status, joining_ptr->process->pid, joining_ptr-trdid );
-#endif
-		joining_ptr->errno = EINVAL;
-		return -1;
+		if((err = cpu_copy_to_uspace(thread_return, &retval, sizeof(void *)))) 
+			goto fail_uspace_ret;
 	}
 
-    // check target thread != this thread
-    if( joining_ptr->trdid == trdid )
-    {
+	spinlock_lock(&task->th_lock);
+	target_th = task->th_tbl[tid];
 
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : joinig thread[%x,%x] == target thread\n",
-__FUNCTION__, joining_ptr->process->pid, joining_ptr->trdid );
-#endif
-        joining_ptr->errno = EDEADLK;
-        return -1;
-    }
+	if((target_th == NULL)                 ||
+	   (target_th->signature != THREAD_ID) || 
+	   (target_th->info.attr.key != tid))
+	{
+		err = ESRCH;
+		goto fail_srch;
+	}
 
-    // get pointers on target thread
-	target_xp  = thread_get_xptr( process->pid , trdid );
-    target_ptr = GET_PTR( target_xp );
+	if(target_th == this)
+	{
+		err = EDEADLK;
+		goto fail_deadlock;
+	}
 
-    if( target_xp == XPTR_NULL )
-    {
+	if(!(thread_isJoinable(target_th)))
+	{
+		err = EINVAL;
+		goto fail_joinable;
+	}
+   
+	spinlock_lock(&target_th->lock);
+   
+	if(target_th->info.join != NULL)
+	{
+		spinlock_unlock(&target_th->lock);
+		err = EINVAL;
+		goto fail_joined;
+	}
 
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : target thread[%x,%x] not found / joining_thread[%x,%x]\n",
-__FUNCTION__, process->pid, trdid, joining_ptr->process->pid, joining_ptr-trdid );
-#endif
-        joining_ptr->errno = ESRCH;
-        return -1;
-    }
+	// Get the exit code of the target thread
+	if ((state=wait_queue_isEmpty(&target_th->info.wait_queue)))
+	{
+		target_th->info.join = this;
+		wait_on(&target_th->info.wait_queue, WAIT_ANY);
+		spinlock_unlock(&target_th->lock);
+		spinlock_unlock_nosched(&task->th_lock);
+		sched_sleep(this);
+		retval = this->info.exit_value;
+	}
+	else
+	{
+		retval = target_th->info.exit_value;
+		wakeup_one(&target_th->info.wait_queue, WAIT_ANY);
+		spinlock_unlock(&target_th->lock);
+		spinlock_unlock(&task->th_lock);
+	}
 
-    // get extended pointers on various fields in target thread
-    target_join_lock_xp   = XPTR( target_cxy , &target_ptr->join_lock );
-    target_flags_xp       = XPTR( target_cxy , &target_ptr->flags );
-    target_join_xp_xp     = XPTR( target_cxy , &target_ptr->join_xp );
-    target_exit_status_xp = XPTR( target_cxy , &target_ptr->exit_status );
+	/* Probably will not fail */
+	if(thread_return)
+	{
+		if((err = cpu_copy_to_uspace(thread_return, &retval, sizeof(void *)))) 
+			goto fail_uspace;
+	}
 
-    // check target thread joinable
-    if( (hal_remote_l32( target_flags_xp ) & THREAD_FLAG_DETACHED) != 0 )
-    {
+	return 0;
 
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : target thread[%x,‰x] not attached / joining thread[%x,%x]\n",
-__FUNCTION__, process->pid, trdid, joining_ptr->process->pid, joining_ptr-trdid );
-#endif
-        joining_ptr->errno = EINVAL; 
-        return -1;
-    }
+fail_joined:
+fail_joinable:
+fail_deadlock:
+fail_srch:
+	spinlock_unlock(&task->th_lock); 
 
-    // mask IRQs
-    hal_disable_irq( &save_sr );
-
-    // get the lock protecting the join in target thread
-    remote_busylock_acquire( target_join_lock_xp );
-
-    // test the kill_done flag from the target thread
-    if( hal_remote_l32( target_flags_xp ) & THREAD_FLAG_KILL_DONE )  // killer is first
-    {
-        // get exit_status from target thread
-        status = (void*)hal_remote_lpt( target_exit_status_xp );
-
-        // get pointers on killer thread
-        killer_xp  = (xptr_t)hal_remote_l64( target_join_xp_xp );
-
-        // reset the kill_done flag in target thread
-        hal_remote_atomic_and( target_flags_xp , ~THREAD_FLAG_KILL_DONE );
-
-        // unblock the killer thread
-        thread_unblock( killer_xp , THREAD_BLOCKED_JOIN );
-
-        // release the lock protecting join      
-        remote_busylock_release( target_join_lock_xp );
-    }
-    else                                                          // joining is first
-    {
-        // set the join_done flag in target thread
-        hal_remote_atomic_or( target_flags_xp , THREAD_FLAG_JOIN_DONE );
-
-        // block joining thread on BLOCKED_JOIN
-        thread_block( joining_xp , THREAD_BLOCKED_JOIN );
-
-        // register the joining thread extended pointer in target thread
-        hal_remote_s64( target_join_xp_xp , joining_xp );
-
-        // release the lock protecting the join      
-        remote_busylock_release( target_join_lock_xp );
-
-#if DEBUG_SYS_THREAD_JOIN 
-if( DEBUG_SYS_THREAD_JOIN < tm_start )
-printk("\n[%s] joining thread[%x,%x] deschedules / target thread[%x,%x] not completed\n",
-__FUNCTION__ , process->pid, joining_ptr->trdid, process->pid, trdid );
-#endif
-        // deschedule
-        sched_yield( "joining thread waiting killer thread" );
-
-        // returns exit_status from joining thread
-        status = joining_ptr->exit_status;
-    }
-    
-    // returns exit_status to user space
-    hal_copy_to_uspace( exit_status,
-                        XPTR( local_cxy , &status ),
-                        sizeof( void* ) );
-
-    // restore IRQs
-    hal_restore_irq( save_sr );
-
-    hal_fence();
-
-#if (DEBUG_SYS_THREAD_JOIN || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_THREAD_JOIN] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_THREAD_JOIN] , 1 );
-#endif
-
-#if DEBUG_SYS_THREAD_JOIN 
-tm_end = hal_get_cycles();
-if( DEBUG_SYS_THREAD_JOIN < tm_end )
-printk("\n[%s] joining thread[%x,%x] exit / target thread[%x,%x] completed / cycle %d\n",
-__FUNCTION__ , process->pid, joining_ptr->trdid, process->pid, trdid, (uint32_t)tm_end );
-#endif
-
-    return 0;
-
-}  // end sys_thread_join()
+fail_uspace:
+fail_uspace_ret:
+fail_arg:
+	this->info.errno = err;
+	return err;
+}
Index: trunk/kernel/syscalls/sys_thread_sleep.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_sleep.c	(revision 690)
+++ trunk/kernel/syscalls/sys_thread_sleep.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_thread_sleep.c - block the calling thread on SLEEP, with or without alarm
+ * kern/sys_thread_sleep.c - puts the current thread in sleep state
  * 
- * Author    Alain Greiner    (2016,2017,2018,2019,2020)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,86 +17,41 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_special.h>
 #include <scheduler.h>
 #include <thread.h>
-#include <printk.h>
-#include <syscalls.h>
+#include <task.h>
 
-///////////////////////////////////////////////////////////////////////////////////////
-// This static function implements the alarm handler used to wake-up a thread
-// when the amarm rings after after a sleep( seconds ) syscall.
-///////////////////////////////////////////////////////////////////////////////////////
-// @ thread_xp  : extended pointer on blocked thread.
-///////////////////////////////////////////////////////////////////////////////////////
-static void __attribute__((noinline)) sleep_alarm_handler( xptr_t thread_xp )
+int sys_thread_sleep()
 {
-    // stop the alarm
-    alarm_stop( thread_xp );
+	struct thread_s *this;
 
-    // unblock the thread
-    thread_unblock( thread_xp , THREAD_BLOCKED_SLEEP );
+	this = current_thread;
 
-}  // end sleep_alarm_handler()
+	if(this->info.isTraced == true)
+	{
+		printk(INFO, "%s: cpu %d, pid %d, tid %d, asked to go sleep [%d]\n", 
+		       __FUNCTION__,
+		       cpu_get_id(),
+		       this->task->pid,
+		       this->info.order,
+		       cpu_time_stamp());
+	}
 
-////////////////////////////////////////
-int sys_thread_sleep( uint32_t seconds )
-{
-    cycle_t    ncycles;    // number of cycles to sleep
-
-    thread_t  * this      = CURRENT_THREAD;
-    xptr_t      thread_xp = XPTR( local_cxy , this );
-
-    cycle_t     tm_start = hal_get_cycles();
-
-#if DEBUG_SYS_THREAD_SLEEP
-if( DEBUG_SYS_THREAD_SLEEP < (uint32_t)tm_start )
-printk("\n[%s] thread[%x,%x] enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, (uint32_t)tm_start );
-#endif
-
-    if( seconds == 0 )   // sleep without alarm
-    {
- 
-#if DEBUG_SYS_THREAD_SLEEP
-if( DEBUG_SYS_THREAD_SLEEP < tm_start )
-printk("\n[%s] thread[%x,%x] blocks on <SLEEP> without alarm / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, (uint32_t)tm_start );
-#endif
-        // threads blocks and deschedules
-        thread_block( thread_xp , THREAD_BLOCKED_SLEEP );
-        sched_yield("sleep without alarm");
-    }
-    else                // sleep with alarm
-    {
-        // translate seconds to ncycles
-        ncycles = seconds * LOCAL_CLUSTER->sys_clk;
-
-        // register & start the calling thread alarm
-        alarm_start( thread_xp,
-                     tm_start + ncycles,
-                     &sleep_alarm_handler,
-                     thread_xp );
+	thread_set_cap_wakeup(this);
+	sched_sleep(this);
   
-#if DEBUG_SYS_THREAD_SLEEP
-if( DEBUG_SYS_THREAD_SLEEP < tm_start )
-printk("\n[DBG] %s : thread[%x,%x] blocks on <SLEEP> for %d seconds / cycle %d\n",
-__FUNCTION__ , this->process->pid,  this->trdid, seconds, (uint32_t)tm_start );
-#endif
-        // thread blocks & deschedules 
-        thread_block( thread_xp , THREAD_BLOCKED_SLEEP );
-        sched_yield("sleep with alarm");
-    }
-
-#if DEBUG_SYS_THREAD_SLEEP
-if( DEBUG_SYS_THREAD_SLEEP < tm_end )
-printk("\n[%s] thread[%x,%x] resume / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, (uint32_t)tm_end );
-#endif
+	if(this->info.isTraced == true)
+	{
+		printk(INFO, "%s: cpu %d, pid %d, tid %d, resuming [%d]\n",
+		       __FUNCTION__,
+		       cpu_get_id(),
+		       this->task->pid,
+		       this->info.order,
+		       cpu_time_stamp());
+	} 
 
 	return 0;
-
-}  // end sys_thread_sleep()
+}
